diff -ur sourceold/scripts/jmgUtility.h source/scripts/jmgUtility.h
--- sourceold/scripts/jmgUtility.h	2019-06-22 07:43:44.247400000 +1000
+++ source/scripts/jmgUtility.h	2019-08-20 10:11:06.817000100 +1000
@@ -240,6 +240,46 @@
 class JmgUtility
 {
 public:
+	struct GenericDateTime
+	{
+		int month;
+		int day;
+		int year;
+		int hour;
+		int minute;
+		int second;
+		unsigned long lTime;
+		GenericDateTime(const GenericDateTime &dateTime)
+		{
+			this->month = dateTime.month;
+			this->day = dateTime.day;
+			this->year = dateTime.year;
+			this->hour = dateTime.hour;
+			this->minute = dateTime.minute;
+			this->second = dateTime.second;
+			this->lTime = dateTime.lTime;
+		}
+		GenericDateTime()
+		{
+			time_t theTime = time(0);
+			struct tm *timeinfo;
+			time(&theTime);
+			timeinfo = localtime(&theTime);
+			this->year = timeinfo->tm_year+1900;
+			this->month = timeinfo->tm_mon+1;
+			this->day = timeinfo->tm_mday;
+			this->hour = timeinfo->tm_hour;
+			this->minute = timeinfo->tm_min;
+			this->second = timeinfo->tm_sec;
+			this->lTime = (long)mktime(timeinfo);
+		}
+		void DebugTime()
+		{
+			char debug[220];
+			sprintf(debug,"msg %d/%d/%d %d:%02d:%02d {%lu}",month,day,year,hour,minute,second,lTime);
+			Console_Input(debug);
+		}
+	};
 	static bool IsInPathfindZone(Vector3 spot)
 	{
 		if (!Get_Random_Pathfind_Spot(spot,5.0f,&spot))
@@ -558,6 +598,16 @@
 			DisplayChatMessage(Player,Red,Green,Blue,MSG);
 		}
 	}
+	static void MessageTeamPlayersAndType(int Red,int Green,int Blue,int Team,const char *MSG)
+	{
+		for (int x = 0;x < 128;x++)
+		{
+			GameObject *Player = Get_GameObj(x);
+			if (!Player || !(Commands->Get_Player_Type(Player) == Team || Get_Team(x) == Team))
+				continue;
+			DisplayChatMessage(Player,Red,Green,Blue,MSG);
+		}
+	}
 	static GameObject *FindNearestPlayer(const Vector3 &pos)
 	{
 		GameObject *nearestPlayer = NULL;
@@ -798,6 +848,16 @@
 		}
 		return true;
 	}
+	static void Create_2D_Wave_Sound_Dialog(const char *soundName)
+	{
+		for (int x = 1;x < 128;x++)
+		{
+			GameObject *player = Get_GameObj(x);
+			if (!player)
+				continue;
+			Create_2D_Wave_Sound_Dialog_Player(player,soundName);
+		}
+	}
 };
 
 class NewObjectiveSystem
@@ -877,10 +937,10 @@
 	{
 		switch (priority)
 		{
-		case Primary: JmgUtility::MessageTeamPlayersType(50,255,50,team,format); break;
-		case Secondary: JmgUtility::MessageTeamPlayersType(50,150,250,team,format); break;
-		case Tertiary:case Unknown: JmgUtility::MessageTeamPlayersType(150,50,150,team,format); break;
-		default: JmgUtility::MessageTeamPlayersType(125,150,150,team,format); break;
+		case Primary: JmgUtility::MessageTeamPlayersAndType(50,255,50,team,format); break;
+		case Secondary: JmgUtility::MessageTeamPlayersAndType(50,150,250,team,format); break;
+		case Tertiary:case Unknown: JmgUtility::MessageTeamPlayersAndType(150,50,150,team,format); break;
+		default: JmgUtility::MessageTeamPlayersAndType(125,150,150,team,format); break;
 		}
 	}
 	void messagePlayerAndColor(GameObject *player,const char *format,Priority priority)
@@ -6725,6 +6785,7 @@
 * \MinUpdateHerdCenter - Min amount of time required for the center point of the herd to reposition
 * \MaxUpdateHerdCenter - Max amount of time required for the center point of the herd to reposition
 * \RunTowardThreatChance - Chance that it'll flee on purpose toward the threat (0.0 - 1.0)
+* \ActionsCrouched - Chance that it will move and stand crouched 0-1.0
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -6880,6 +6941,7 @@
 	float minWanderFrequency;
 	float maxWanderFrequency;
 	float runTowardThreatChance;
+	float actionCrouched;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *seen);
 	void Timer_Expired(GameObject *obj,int number);
@@ -7947,4 +8009,24 @@
 	int count;
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Sends a custom when a player is seen, ignores team -4 (spec) and non-visible
+* \ID - ID to send the custom to, 0 sends to self, -1 sends to enter
+* \Custom - Custom message to send
+* \Param - Param to send
+* \Delay - Delay to add before sending custom
+* \TriggerOnce - Allows the script only to trigger the first time the zone is entered
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Player_Seen_Send_Custom : public ScriptImpClass {
+	int id;
+	int custom;
+	int Param;
+	float delay;
+	bool triggerOnce;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
 };
\ No newline at end of file
diff -ur sourceold/scripts/scripts.h source/scripts/scripts.h
--- sourceold/scripts/scripts.h	2018-11-17 10:23:57.259600000 +1000
+++ source/scripts/scripts.h	2019-08-20 10:11:06.818000100 +1000
@@ -318,6 +318,18 @@
 class ActionParamsStruct {
 public:
 	ActionParamsStruct( void );
+	void Set_Basic_Old(ScriptClass *s,unsigned long priority,unsigned long ID,long state);
+	void Set_Attack_Hold(GameObject *Target,float range,float deviation,bool primary,bool Hold);
+	void Set_Attack_Position(const Vector3 & position,float Range,float Deviation,bool Primary);
+	void Set_Goto_Location(const Vector3 & position,float speed,float arrivedistance,bool crouch);
+	void Set_Goto_Following(GameObject *Target,float speed,float arrivedistance,bool following);
+	void Set_Goto_Crouch(GameObject *Target,float speed,float arrivedistance,bool crouch);
+	void Set_Goto_Crouch_Following(GameObject *Target,float speed,float arrivedistance,bool crouch,bool following);
+	void Set_Goto(GameObject *Target,float speed,float arrivedistance);
+	void Set_Goto_Waypath_Start(unsigned long waypathID,unsigned long waypathstartID,unsigned long waypathendID,bool splined);
+	void Set_Goto_Waypath(unsigned long waypathID,bool splined,bool v57,bool Hold);
+	void Set_Goto_Waypath_ID(unsigned long waypathID);
+	void Set_Move_Arrive_Distance(float distance);
 	void Set_Basic( GameObjObserverClass * script, float priority, int action_id, SoldierAIState ai_state = NO_AI_STATE_CHANGE ) { ObserverID = script->Get_ID(); Priority = (int)priority; ActionID = action_id; AIState = ai_state; }
 	void Set_Basic( long observer_id, float priority, int action_id, SoldierAIState ai_state = NO_AI_STATE_CHANGE ) { ObserverID = observer_id; Priority = (int)priority; ActionID = action_id; AIState = ai_state; }
 	void Set_Look( const Vector3 & location, float duration ) { LookLocation = location; LookDuration = duration; }	
@@ -450,6 +462,89 @@
 	LookDuration	= duration;
 	return ;
 }
+void inline ActionParamsStruct::Set_Move_Arrive_Distance(float distance)
+{
+	MoveArrivedDistance = distance;
+}
+void inline ActionParamsStruct::Set_Goto_Location(const Vector3 & position,float speed,float arrivedistance,bool crouch)
+{
+	MoveLocation.X = position.X;
+	MoveLocation.Y = position.Y;
+	MoveLocation.Z = position.Z;
+	MoveSpeed = speed;
+	MoveArrivedDistance = arrivedistance;
+	MoveCrouched = crouch;
+}
+void inline ActionParamsStruct::Set_Goto_Following(GameObject *Target,float speed,float arrivedistance,bool following)
+{
+	MoveObject = Target;
+	MoveSpeed = speed;
+	MoveArrivedDistance = arrivedistance;
+	MoveFollow = following;
+}
+void inline ActionParamsStruct::Set_Goto_Crouch(GameObject *Target,float speed,float arrivedistance,bool crouch)
+{
+	MoveObject = Target;
+	MoveSpeed = speed;
+	MoveArrivedDistance = arrivedistance;
+	MoveCrouched = crouch;
+}
+void inline ActionParamsStruct::Set_Goto_Crouch_Following(GameObject *Target,float speed,float arrivedistance,bool crouch,bool following)
+{
+	MoveObject = Target;
+	MoveSpeed = speed;
+	MoveArrivedDistance = arrivedistance;
+	MoveCrouched = crouch;
+	MoveFollow = following;
+}
+void inline ActionParamsStruct::Set_Goto(GameObject *Target,float speed,float arrivedistance)
+{
+	MoveObject = Target;
+	MoveSpeed = speed;
+	MoveArrivedDistance = arrivedistance;
+}
+void inline ActionParamsStruct::Set_Goto_Waypath_Start(unsigned long waypathID,unsigned long waypathstartID,unsigned long waypathendID,bool splined)
+{
+	WaypathID = waypathID;
+	WaypointStartID = waypathstartID;
+	WaypointEndID = waypathendID;
+	WaypathSplined = splined;
+}
+void inline ActionParamsStruct::Set_Goto_Waypath(unsigned long waypathID,bool splined,bool v57,bool Hold)
+{
+	WaypathID = waypathID;
+	WaypathSplined = splined;
+	AttackActive = v57;
+	AttackCheckBlocked = Hold;
+}
+void inline ActionParamsStruct::Set_Goto_Waypath_ID(unsigned long waypathID)
+{
+	WaypathID = waypathID;
+}
+void inline ActionParamsStruct::Set_Basic_Old(ScriptClass *s,unsigned long priority,unsigned long ID,long state)
+{
+	ID = s->Get_ID();
+	Priority = priority;
+	ActionID = ID;
+	AIState = (SoldierAIState)state;
+}
+void inline ActionParamsStruct::Set_Attack_Hold(GameObject *Target,float Range,float Deviation,bool Primary,bool Hold)
+{
+	AttackObject = Target;
+	AttackRange = Range;
+	AttackError = Deviation;
+	AttackPrimaryFire = Primary;
+	AttackCheckBlocked = Hold;
+}
+void inline ActionParamsStruct::Set_Attack_Position(const Vector3 & position,float Range,float Deviation,bool Primary)
+{
+	AttackRange = Range;
+	AttackLocation.X = position.X;
+	AttackLocation.Y = position.Y;
+	AttackLocation.Z = position.Z;
+	AttackError = Deviation;
+	AttackPrimaryFire = Primary;
+}
 
 enum {
 	CUSTOM_EVENT_SYSTEM_FIRST = 1000000000,
